//
//    
//  -web-cam-
// 
// robocraft.ru

#include <cv.h>
#include <highgui.h>
#include <stdlib.h>
#include <stdio.h>

#include "serial.h"

Serial sg; //    COM-

//  1- 
int A = 0;
int Amax = 180;

//  2- 
int F = 0;
int Fmax = 180;

IplImage* dest = 0;

//
// - 
//
void myTrackbarA(int pos) {
	A = pos;
	// Firmata
	char buf[3];
	buf[0] = 0xE0 | 7;
	buf[1] = A & 0x7F;
	buf[2] = (A >> 7) & 0x7F;
	sg.Send(buf, 3);
	Sleep(100);
}

void myTrackbarF(int pos) {
	F = pos;
	// Firmata
	char buf[3];
	buf[0] = 0xE0 | 8;
	buf[1] = F & 0x7F;
	buf[2] = (F >> 7) & 0x7F;
	sg.Send(buf, 3);
	Sleep(100);

}

//      
void rotate(IplImage* _image, double _angle=90)
{
	//  
	CvMat* rot_mat = cvCreateMat(2,3,CV_32FC1);
	//    
	CvPoint2D32f center = cvPoint2D32f(_image->width/2, _image->height/2);
	double angle = _angle;
	double scale = 1;
	cv2DRotationMatrix(center,angle,scale,rot_mat);
	
	IplImage* Temp = 0;
	Temp = cvCreateImage(cvSize(_image->width, _image->height) , _image->depth, _image->nChannels);

	//  
	cvWarpAffine(_image,Temp,rot_mat);

	//  
	cvCopy(Temp, _image);

	cvReleaseImage(&Temp);
	cvReleaseMat(&rot_mat);
}

int main(int argc, char* argv[])
{
	//    
	CvCapture* capture = cvCaptureFromCAM(CV_CAP_ANY);
	assert( capture );

	//     
	cvSetCaptureProperty(capture, CV_CAP_PROP_FRAME_WIDTH, 640);//1280); 
	cvSetCaptureProperty(capture, CV_CAP_PROP_FRAME_HEIGHT, 480);//960); 


	IplImage* frame=0;

     //    
	cvNamedWindow("capture", CV_WINDOW_AUTOSIZE);

	//  COM-
	int port=19; //   COM- Arduino
	printf("[i] try to open COM-port %d\n", port);
	bool b = sg.Open(port, 9600);
	if(!b)
	{
		printf("[!] Error open COM-port!\n");
		return 1;
	}
	printf("[i] ok\n");

	//      
	cvCreateTrackbar("A", "capture", &A, Amax, myTrackbarA);
	cvCreateTrackbar("F", "capture", &F, Fmax, myTrackbarF);

     //     
	while(true){
		//  
		frame = cvQueryFrame( capture );
          //  
		dest = cvCloneImage(frame);

		//    90 
		rotate(dest);

		// 
		cvShowImage("capture", dest);

		//  
		cvReleaseImage(&dest);
	
		char c = cvWaitKey(33);
		if (c == 27) { //  ESC
			break;
		}
	}
	//  
	sg.Close();
	cvReleaseCapture( &capture );
	cvDestroyWindow("capture");
	return 0;
}
